VehicleManager_Display_MouseKeyEventsBox = {};

function VehicleManager_Display_MouseKeyEventsBox.onClick(args)
	if args == nil or type(args) ~= "table" or args.clickAreaTable == nil then return;end;
	if args.isDown then
		if g_currentMission.hlUtils.dragDrop.on then return;end;
		if args.button == Input.MOUSE_BUTTON_LEFT then
			local box = args.box;
			if box ~= nil then
				if args.clickAreaTable.whereClick == "settingInBox_" and args.clickAreaTable.areaClick == "settingIcon_" then
					if box.isSetting then 
						box.ownTable.lastStateExtraLine=box.viewExtraLine;
						box.viewExtraLine = true;
						box.ownTable.modus[1] = 1;
						vmGroups:closeAllOpenGroups();
						--if VehicleManager_Display.autoDrive.loaded then adc_SetGet:setVmAdHud(false);end;
					else 
						box.viewExtraLine = box.ownTable.lastStateExtraLine;						
					end;
				elseif args.clickAreaTable.whereClick == "settingInBox_" and args.clickAreaTable.areaClick == "menueClose_" then
					box.isSetting = false;box.viewExtraLine = box.ownTable.lastStateExtraLine;box.ownTable.modus[1] = 1;
					--if VehicleManager_Display.autoDrive.loaded then adc_SetGet:setVmAdHud(false);end;
				elseif args.clickAreaTable.whereClick == "settingInBox_" and args.clickAreaTable.areaClick == "viewExtraLine_" then
					box.ownTable.lastStateExtraLine=box.viewExtraLine;
				end;
			end;
		end;
	end;
end;

function VehicleManager_Display_MouseKeyEventsBox.onClickArea(args)
	if args == nil or type(args) ~= "table" or args.clickAreaTable == nil then return;end;
		
	if args.isDown then
		if g_currentMission.hlUtils.dragDrop.on then return;end;
		if args.button == Input.MOUSE_BUTTON_LEFT then
			local box = args.box;
			if box ~= nil then
				if box.viewExtraLine then					
					if args.clickAreaTable.whereClick == "settingGenerateGroups_" then
						if vmGroupsXml:canSaveBySavegame() then
							vmGroups:generateNewGroups(box, args.clickAreaTable.ownTable.group);
						else
							return;
						end;
					elseif args.clickAreaTable.whereClick == "settingRenameGroups_" then
						if args.clickAreaTable.ownTable.name ~= nil and args.clickAreaTable.ownTable.group ~= nil then
							vmGroups:renameGroups(args.clickAreaTable.ownTable.name, args.clickAreaTable.ownTable.group, args.clickAreaTable.ownTable.uGroup);
						end;
					elseif args.clickAreaTable.whereClick == "settingDeleteGroups_" then
						if args.clickAreaTable.ownTable.name ~= nil and args.clickAreaTable.ownTable.group ~= nil then
							vmGroups:deleteGroups(args.clickAreaTable.ownTable.name, args.clickAreaTable.ownTable.group, args.clickAreaTable.ownTable.uGroup);
						end;
					elseif args.clickAreaTable.whereClick == "settingNewPositionGroups_" then
						if args.clickAreaTable.ownTable.name ~= nil and args.clickAreaTable.ownTable.group ~= nil then
							vmGroups:newGroupsPosition("up", args.clickAreaTable.ownTable.name, args.clickAreaTable.ownTable.group, args.clickAreaTable.ownTable.uGroup);
						end;
					elseif args.clickAreaTable.whereClick == "settingNewPositionNextGroup_" then
						if args.clickAreaTable.ownTable.name ~= nil and args.clickAreaTable.ownTable.group ~= nil then
							vmGroups:setUgroupNextGroup("up", args.clickAreaTable.ownTable.name, args.clickAreaTable.ownTable.group, args.clickAreaTable.ownTable.uGroup);
						end;
					elseif args.clickAreaTable.whereClick == "view_" then
						if args.clickAreaTable.ownTable[1] ~= nil and box.ownTable.view[args.clickAreaTable.ownTable[1]] ~= nil then
							if (args.clickAreaTable.ownTable[1] == "driverActiveIcon" or args.clickAreaTable.ownTable[1] == "adHudIcon") and #vmGroups.values.groups <= 0 then return;end;
							local values = box.ownTable.view[args.clickAreaTable.ownTable[1]];
							if values[1]+1 > values[3] then
								values[1] = values[2];
							else
								values[1] = values[1]+1;
							end;
							if args.clickAreaTable.ownTable[1] == "adHudIcon" and values[1] == 1 then adc_SetGet:setVmAdHud(false);end;
							g_currentMission.hlHudSystem.isSave = false; --global						
						end;					
					elseif args.clickAreaTable.whereClick == "closeAllDetailsLines_" then
						vmGroups:closeAllOpenGroups();					
						return;
					elseif args.clickAreaTable.whereClick == "modus_" then
						if box.isSetting or #vmGroups.values.groups <= 0 then return;end;
						local values = box.ownTable.modus;					
						if values[1]+1 > values[3] then
							values[1] = values[2];							
						else
							values[1] = values[1]+1;							
						end;
						if values[1] == 1 then 
							if g_currentMission.hlUtils.timers["vm_boxEditModus_"] ~= nil then g_currentMission.hlUtils.removeTimer("vm_boxEditModus_");end;
						else							
							if g_currentMission.hlUtils.timers["vm_boxEditModus_"] == nil then g_currentMission.hlUtils.addTimer( {delay=box.ownTable.modus[4], name="vm_boxEditModus_", ms=false, action=VehicleManager_DisplaySetGet.addInfoMsg, ownTable={"vm_boxEditModus_"} } );end;							
						end;
					elseif args.clickAreaTable.whereClick == "settingTyp_" then
						if box.settingTyp >= box.ownTable.settingTyp[3] then 
							box.ownTable.settingTyp[1] = box.ownTable.settingTyp[2];							
						else 
							box.ownTable.settingTyp[1] = box.ownTable.settingTyp[1]+1;							
						end;
						box.settingTyp = box.ownTable.settingTyp[1];
						box:setUpdateState(true);
					elseif args.clickAreaTable.whereClick == "settingGuiBox_" then
						box.guiMenu:setShow(not box.guiMenu.show);
						return;	
					elseif args.clickAreaTable.whereClick == "settingLineDistance_" then
						local maxDistance = box.screen.pixelH*8;
						if box.screen.size.distance.textLine+(box.screen.pixelH/2) <= maxDistance then
							box.screen.size.distance.textLine = box.screen.size.distance.textLine+(box.screen.pixelH/2);
							box:setUpdateState(true);							
						end;
						return;
					elseif args.clickAreaTable.whereClick == "settingCopyPasteVorlage_" then						
						g_currentMission.hlHudSystem:yesNoDialog( {title="VehicleManager Info", text=string.format(g_i18n:getText("profile_copyPaste"), g_i18n:getText("profile_vorlage")), callback=vmGroupsXml.copyPasteProfil ,ownTable={profilName="vm_Vorlage_Profil", isVorlage=true}} );
					elseif args.clickAreaTable.whereClick == "settingGenerateVorlage_" then						
						vmGroupsXml:generateVorlageProfil(args.clickAreaTable.ownTable.profilName);
					end;					
				end;
				if args.clickAreaTable.whereClick == "viewTypGroups_" then
					if args.clickAreaTable.ownTable.name ~= nil and args.clickAreaTable.ownTable.group ~= nil then
						if not VehicleManager_Display.vehicleInspector then
							g_currentMission.hlUtils.addTextDisplay( {txt=g_i18n:getText("groups_viNotFound"), txtBold=true, duration=4, warning=true} );
							return;						
						end;
						if args.clickAreaTable.ownTable.uGroup ~= nil then
							if vmGroups.values.groups[args.clickAreaTable.ownTable.group].uGroups[args.clickAreaTable.ownTable.uGroup].viewTyp+1 > vmGroups.values.groups[args.clickAreaTable.ownTable.group].uGroups[args.clickAreaTable.ownTable.uGroup].maxViewTyp then
								vmGroups.values.groups[args.clickAreaTable.ownTable.group].uGroups[args.clickAreaTable.ownTable.uGroup].viewTyp = 1;
							else
								vmGroups.values.groups[args.clickAreaTable.ownTable.group].uGroups[args.clickAreaTable.ownTable.uGroup].viewTyp = vmGroups.values.groups[args.clickAreaTable.ownTable.group].uGroups[args.clickAreaTable.ownTable.uGroup].viewTyp+1;
							end;
							vmGroupsXml:saveProfil();
						else
							if vmGroups.values.groups[args.clickAreaTable.ownTable.group].viewTyp+1 > vmGroups.values.groups[args.clickAreaTable.ownTable.group].maxViewTyp then 
								vmGroups.values.groups[args.clickAreaTable.ownTable.group].viewTyp = 1;
							else
								vmGroups.values.groups[args.clickAreaTable.ownTable.group].viewTyp = vmGroups.values.groups[args.clickAreaTable.ownTable.group].viewTyp+1;
							end;
							vmGroupsXml:saveProfil();
						end;
					end;
				elseif args.clickAreaTable.whereClick == "groupsName_" or args.clickAreaTable.whereClick == "groupsFolder_" then
					if args.clickAreaTable.ownTable.name ~= nil and args.clickAreaTable.ownTable.group ~= nil then
						if args.clickAreaTable.ownTable.uGroup ~= nil then
							local uGroup = vmGroups.values.groups[args.clickAreaTable.ownTable.group].uGroups[args.clickAreaTable.ownTable.uGroup];
							if uGroup.viewOpen then
								uGroup.viewOpen = false;
							else
								if not box.isSetting and vmGroups:getTypIdLength(uGroup.typId) > 0 then uGroup.viewOpen = true;end;
							end;
						else
							local group = vmGroups.values.groups[args.clickAreaTable.ownTable.group];
							if group.viewOpen then
								group.viewOpen = false;
							else
								if box.isSetting and #group.uGroups > 0 then group.viewOpen = true;elseif not box.isSetting and (#group.uGroups > 0 or vmGroups:getTypIdLength(group.typId) > 0) then group.viewOpen = true;end;
								if box.isSetting and not group.viewOpen then g_currentMission.hlUtils.addTextDisplay( {txt=string.format(g_i18n:getText("groups_settingNotFoundUgroups"), args.clickAreaTable.ownTable.name), txtBold=true, duration=3, warning=true} );end;								
							end;
						end;
					end;
				elseif args.clickAreaTable.whereClick == "vehicleName_" or args.clickAreaTable.whereClick == "vehicleIcon_" then
					if args.clickAreaTable.ownTable.vehicleNode ~= nil and args.clickAreaTable.ownTable.name ~= nil and args.clickAreaTable.ownTable.group ~= nil then
						if args.clickAreaTable.ownTable.vehicleName ~= nil and args.clickAreaTable.ownTable.vehicleName == "Ghost Vehicle TypId" and args.clickAreaTable.ownTable.typId ~= nil then
							vmGroups:delVehicleAtGroup(args.clickAreaTable.ownTable.vehicleNode, args.clickAreaTable.ownTable.typId, args.clickAreaTable.ownTable.group, args.clickAreaTable.ownTable.uGroup);	
						else
							VehicleManager_DisplaySetGet:clickVehicleName("left", args.clickAreaTable.ownTable.vehicleNode, box.ownTable.modus[1] == 1);
						end;
					end;
				elseif args.clickAreaTable.whereClick == "adIcon_" then
					if args.clickAreaTable.ownTable.vehicleNode ~= nil then
						--adc_SetGet:clickVehicleAdBoxIcon("left", args.clickAreaTable.ownTable.vehicleNode);
					end;
				elseif args.clickAreaTable.whereClick == "ghostVehicle_" then
					if args.clickAreaTable.ownTable.vehicleNode ~= nil and args.clickAreaTable.ownTable.typId ~= nil and args.clickAreaTable.ownTable.group ~= nil then						
						vmGroups:delVehicleAtGroup(args.clickAreaTable.ownTable.vehicleNode, args.clickAreaTable.ownTable.typId, args.clickAreaTable.ownTable.group, args.clickAreaTable.ownTable.uGroup);												
					end;										
				elseif args.clickAreaTable.whereClick == "profilCopyPaste_" then
					if args.clickAreaTable.ownTable.profilName ~= nil then						
						if not vmGroups:hasProfilGroups() then g_currentMission.hlHudSystem.showInfoBox( {g_i18n:getText("profile_vorlage_notGenerate"), 2500, g_currentMission.hlUtils.getColor("orangeRed", true)} );return;end;
						g_currentMission.hlHudSystem:yesNoDialog( {title="VehicleManager Info", text=string.format(g_i18n:getText("profile_copyPaste"), args.clickAreaTable.ownTable.profilName), callback=vmGroupsXml.copyPasteProfil ,ownTable={profilName=args.clickAreaTable.ownTable.profilName,isVorlage=false}} );
					end;
				elseif args.clickAreaTable.whereClick == "profilName_" then
					if args.clickAreaTable.ownTable.profilName ~= nil then						
						local txt = "../modSettings/HL/FS25_VehicleManagerDisplay/profile/";						
						if VehicleManager_Display:getHostOrSp() then
							txt = "../savegame" .. g_currentMission.missionInfo.savegameIndex.. "/"
						end;
						g_currentMission.hlHudSystem:addTextDisplay( {txt=txt.. "\n".. tostring(args.clickAreaTable.ownTable.profilName).. ".xml", maxLine=2, duration=7} );
					end;
				elseif args.clickAreaTable.whereClick == "notFoundGroups_" then --first start, groups
					if not box.isSetting then 
						box.isSetting = true;
						box.ownTable.settingTyp[1] = 2;
						box.settingTyp = 2;						
					end;				
				end;
			end;
		elseif args.button == Input.MOUSE_BUTTON_RIGHT then
			local box = args.box;
			if box ~= nil then
				if box.viewExtraLine then					
					if args.clickAreaTable.whereClick == "settingNewPositionGroups_" then
						if args.clickAreaTable.ownTable.name ~= nil and args.clickAreaTable.ownTable.group ~= nil then
							vmGroups:newGroupsPosition("down", args.clickAreaTable.ownTable.name, args.clickAreaTable.ownTable.group, args.clickAreaTable.ownTable.uGroup);
						end;						
					elseif args.clickAreaTable.whereClick == "settingNewPositionNextGroup_" then
						if args.clickAreaTable.ownTable.name ~= nil and args.clickAreaTable.ownTable.group ~= nil then
							vmGroups:setUgroupNextGroup("down", args.clickAreaTable.ownTable.name, args.clickAreaTable.ownTable.group, args.clickAreaTable.ownTable.uGroup);
						end;
					elseif args.clickAreaTable.whereClick == "settingTyp_" then
						if box.settingTyp <= box.ownTable.settingTyp[2] then 
							box.ownTable.settingTyp[1] = box.ownTable.settingTyp[3];							
						else 
							box.ownTable.settingTyp[1] = box.ownTable.settingTyp[1]-1;							
						end;
						box.settingTyp = box.ownTable.settingTyp[1];
						box:setUpdateState(true);
					elseif args.clickAreaTable.whereClick == "settingLineDistance_" then
						local minDistance = box.screen.pixelH*1;
						if box.screen.size.distance.textLine-(box.screen.pixelH/2) >= minDistance then
							box.screen.size.distance.textLine = box.screen.size.distance.textLine-(box.screen.pixelH/2);
							box:setUpdateState(true);							
						end;
						return;					
					end;					
				end;
				if args.clickAreaTable.whereClick == "viewTypGroups_" then
					if args.clickAreaTable.ownTable.name ~= nil and args.clickAreaTable.ownTable.group ~= nil then
						if not VehicleManager_Display.vehicleInspector then
							g_currentMission.hlUtils.addTextDisplay( {txt=g_i18n:getText("groups_viNotFound"), txtBold=true, duration=4, warning=true} );
							return;						
						end;
						if args.clickAreaTable.ownTable.uGroup == nil then
							vmGroups:setAllGroupViewTypOff(args.clickAreaTable.ownTable.group);
						end;
					end;
				elseif args.clickAreaTable.whereClick == "groupsName_" then
					if box.ownTable.modus[1] == 2 then
						if args.clickAreaTable.ownTable.name ~= nil and args.clickAreaTable.ownTable.group ~= nil then
							local player = g_localPlayer;
							if player == nil then return;end;
							local vehicle = player:getCurrentVehicle();
							if vehicle == nil then g_currentMission.hlUtils.addTextDisplay( {txt=g_i18n:getText("box_modus2_insertRemoveError"), maxLine=0, txtBold=true, duration=4, warning=true} );return;end;
							if vehicle.vmControl == nil then g_currentMission.hlUtils.addTextDisplay( {txt=g_i18n:getText("box_modus2_noSupportError"), maxLine=0, txtBold=true, duration=4, warning=true} );return;end;
							vmGroups:setVehicleAtGroup(vehicle.rootNode, vehicle.vmControl.typId, args.clickAreaTable.ownTable.group, args.clickAreaTable.ownTable.uGroup);
						end;
					end;
				elseif args.clickAreaTable.whereClick == "vehicleName_" or args.clickAreaTable.whereClick == "vehicleIcon_" then
					if args.clickAreaTable.ownTable.vehicleNode ~= nil and args.clickAreaTable.ownTable.name ~= nil and args.clickAreaTable.ownTable.group ~= nil then
						local vehicle = g_currentMission.nodeToObject[args.clickAreaTable.ownTable.vehicleNode];										
						if box.ownTable.modus[1] == 2 then
							if vehicle ~= nil and vehicle.vmControl ~= nil then 
								vmGroups:delVehicleAtGroup(args.clickAreaTable.ownTable.vehicleNode, vehicle.vmControl.typId, args.clickAreaTable.ownTable.group, args.clickAreaTable.ownTable.uGroup);
							elseif args.clickAreaTable.ownTable.vehicleName ~= nil and args.clickAreaTable.ownTable.vehicleName == "Ghost Vehicle TypId" and args.clickAreaTable.ownTable.typId ~= nil then
								vmGroups:delVehicleAtGroup(args.clickAreaTable.ownTable.vehicleNode, args.clickAreaTable.ownTable.typId, args.clickAreaTable.ownTable.group, args.clickAreaTable.ownTable.uGroup);
							else
								--VehicleManager_DisplaySetGet:clickVehicleName("right", args.clickAreaTable.ownTable.vehicleNode); --not function
							end;
						else
							VehicleManager_DisplaySetGet:clickVehicleName("right", args.clickAreaTable.ownTable.vehicleNode);
						end;
					end;
				elseif args.clickAreaTable.whereClick == "adIcon_" then
					if args.clickAreaTable.ownTable.vehicleNode ~= nil then
						--adc_SetGet:clickVehicleAdBoxIcon("right", args.clickAreaTable.ownTable.vehicleNode);
					end;
				elseif args.clickAreaTable.whereClick == "notFoundGroups_" then --first start, profile
					if not box.isSetting then 
						box.isSetting = true;
						box.ownTable.settingTyp[1] = 3;
						box.settingTyp = 3;						
					end;
				end;
			end;
		elseif args.button == Input.MOUSE_BUTTON_MIDDLE then
			local box = args.box;
			if box ~= nil then
				if box.viewExtraLine then
					
				end;				
			end;
		end;	
	end;
end;